﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;

using System.Windows.Forms;  // ClipBoard
using System.Data;

using FirebirdSql.Data.FirebirdClient;
using System.Collections;  // hashtable

namespace DbsConsole
{
    class Dbs
    {
        FbConnection _cnn;
        public void setDbs(string sDatabaseFile)
        {
            String sFilename;
            int i = sDatabaseFile.LastIndexOf('\\');
            if (i == -1)
                sFilename = sDatabaseFile;
            else
            {
                sFilename = sDatabaseFile.Substring(i + 1);
            }
            // Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            string sPath;
            sPath = Environment.CurrentDirectory;
            //sPath = "C:\\Daten";
            if (!sPath.EndsWith("\\")) sPath += "\\";
            string sArg =
                "User=SYSDBA;" +
                "Password=masterkey;" +
                "Database=" + sFilename + ";" +
                "DataSource=localhost;" +
                "Port=3050;" +
                "Dialect=3;" +
                "Charset=NONE;" +
                "Role=;" +
                "Connection lifetime=15;" +
                "Pooling=true;" +
                "MinPoolSize=0;" +
                "MaxPoolSize=50;" +
                "Packet Size=8192;" +
                "ServerType=1";

            _cnn = new FbConnection(sArg);
            if (_cnn == null)
                MessageBox.Show("Fehler beim Öffnen der Datenbank\r\n" +
                      sPath + sDatabaseFile, "Fehler");
            else
                _cnn.Open();
        }  // dbs

        //_dbs.createDatabase("C:\\Daten\\test1.fdb");
        public void createDatabase(string sFilename)
        {
            Hashtable htable = new Hashtable();
            htable.Add("Database", sFilename);
            htable.Add("User", "SYSDBA");
            htable.Add("Password", "masterkey");
            htable.Add("Dialect", 3);  // SQL Version
            htable.Add("DataSource", "localhost");
            htable.Add("Port", 3050);
            //htable.Add("Charset","Database Character Set.");
            htable.Add("PageSize", 4096);
            htable.Add("ForcedWrite", true);
            htable.Add("ServerType", 1);  // ???? 

            //FbConnection.CreateDatabase(htable);
            string sArg =
                "User=SYSDBA;" +
                "Password=masterkey;" +
                "Database=" + sFilename + ";" +
                "DataSource=localhost;" +
                "Port=3050;" +
                "Dialect=3;" +
                "Charset=NONE;" +
                "Role=;" +
                "Connection lifetime=15;" +
                "Pooling=true;" +
                "MinPoolSize=0;" +
                "MaxPoolSize=50;" +
                "Packet Size=8192;" +
                "ServerType=1";

            FbConnection.CreateDatabase(sArg);
            //FbConnection.CreateDatabase(connectionstring, pagesize, forcedwrite, overwrite
        }

        public void Close()
        {
            _cnn.Close();
        }

        public DataTable GetSchema(string sItem, string[] filter)
        {
            return _cnn.GetSchema(sItem, filter);
        }

        public DataTable getDBSData(string sSQL)
        {
            FbDataAdapter da = new FbDataAdapter(sSQL, _cnn);
            DataTable dt = new DataTable("RELATIONS");
            da.Fill(dt);
            da.Dispose();
            return dt;
        }



    }
}
